/******************************************************
 * 	flashlibrary.c
 * 
 * 	Funktionen fr die Flash-Befehle
 * 
 ******************************************************/

#include "flash.h"
#include "flashlibrary.h"
#include "asc0.h"
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>


	/********************************************************************
	 * int parse_hex_line(char *theline, int *bytes, int *addr, int *num, int *code)
	 *
	 * parses a line of intel hex code, stores the data in bytes[]
	 * and the beginning address in addr, and returns a 1 if the 
	 * line was valid, or a 0 if an error occured. The variable 
	 * num gets the number of bytes that were stored into bytes[] 
	 * 
	 ********************************************************************/

		//theline ist z.b ein char Array: char zeile[255];
		//bytes ist ein int Array: int daten[255];
		//in addr steht nach dem Aufruf die geparste Adresse
		//in num die Anzahl der geschriebenen Bytes in das *bytes Array.
		//in code steht der geparste identifier-code aus dem intel-hex-file


		int parse_hex_line(char *theline, int *bytes, int *addr, int *num, int *code)
		{
		int sum, len, cksum;
		char *ptr;
				
		*num = 0;
		if (theline[0] != ':') return 0; 					//checken ob Array mit : anfngt
		if (strlen(theline) < 11) return 0; 				//ist Zeile lnger als 11
		ptr = theline+1;
		if (!sscanf(ptr, "%02x", &len)) return 0; 			//Lnge rausparsen
		ptr += 2;
		if ( strlen(theline) < (11 + (len * 2)) ) return 0; //Lnge checken
		if (!sscanf(ptr, "%04x", addr)) return 0; 			//Adresse rausparsen
		ptr += 4;
		/* printf("Line: length=%d Addr=%d\n", len, *addr); */
		if (!sscanf(ptr, "%02x", code)) return 0; 			//Code rausparsen
		ptr += 2;
		sum = (len & 255) + ((*addr >> 8) & 255) + (*addr & 255) +
		(*code & 255); 										//Checksum berechnen
		while(*num != len) {
		if (!sscanf(ptr, "%02x", &bytes[*num])) return 0;
		//daten in bytes array abspeichern
		ptr += 2;
		sum += bytes[*num] & 255; 							//Checksum aufsummieren
		(*num)++;
		if (*num >= 256) return 0;
		}
		if (!sscanf(ptr, "%02x", &cksum)) return 0; 		//Checksum rausparsen
		if ( ((sum & 255) + (cksum & 255)) & 255 ) return 0; 	/* Checksum error feststellen*/
		return 1; 
		}

	/********************************************************************
	 * void write_hex_out (int adr, int *buffer, int length)
	 *
	 * Schreibt eine Zeile im Intel Hex Format auf die serielle
	 * Schnittstelle.
	 * 
	 * 
	 ********************************************************************/

	void write_hex_out (int adr, int *buffer, int length)
	{
	  	int sum=0, i=0;
	  	asc0_printf(":%02X%04X00", length, adr);
		sum = length + ((adr>>8)&255) + (adr&255);
			for (i=0; i < length; i++)
		 		{
				asc0_printf("%02X", (*(buffer+i))&255);
				sum += (*(buffer+i))&255;
				}
		asc0_printf("%02X\n", (-sum)&255);
	}


	/********************************************************************
	 * void hello (void)
	 *
	 * flash the leds to show that flashtool is on uC.
	 * 
	 ********************************************************************/

	void hello (void)
	{
	DP2 = 0xFFFF;
	P2 = 0x0000;
	}

