/******************************************************
 * 	haupt.c
 * 
 * 	Hauptfunktionen fr die Verarbeitung der Befehle
 * 
 * 	Works with the simulator as well !
 *
 *	Aigner Stefan, Ebermann Gnter, Herdin Werner
 *  Homolar Walter, Koch Ren
 ******************************************************/


#include "asc0.h"
#include "flash.h"
#include "flashlibrary.h"
#include <reg167.h>
#define MAXHEXLINE 16	/* the maximum number of bytes to put in one line */


	/********************************************************************
	 * 	void main (void)
	 *
	 *	Hauptfunktion fr das Flash-Programm. 
	 *
	 ********************************************************************/

	void main (void)
	{
	uchar packet[255];		// Empfangspacket
	int bytes[255];		    // Datenbytes
	int number, code, adresse;
	unsigned int adr = 0;
	unsigned int extadress = 0;
	unsigned int zwei_bytes = 0;
	int i=0, k=0, m=0, sum=0;
    int fehler;				// Variable fr Fehler
 	int buffer_pos = 0;

	init_asc0();			// Serielle Schnittstelle initialisieren
	IEN=1;					// Interrupt Enable
	hello(); 				// dreht die Lichter auf

	while(1)
		{
		i=0;
		packet[i]=0;
		do
			{
			packet[i]=asc0_get();
			i++;	
		 	}
		while (packet[i-2] != 0x0D && packet[i-1] != 0x0A); 			// new line detected
		fehler=parse_hex_line(packet, bytes, &adresse, &number, &code);	// Parsen des Packets
		adr = extadress + adresse;
		//asc0_printf("adress %X",adr); //asc0_printf("number %X ",number);		

		if (fehler == 0)
			{
		   	asc0_put('P'); 		// pruefsumme fehler
			}
	    else
			{
		   	asc0_put('p');		// wenn pruefsumme ok		
        	}

		if (code==0)			// schreiben
			{
			reset();		
	 		for (m=0; m<number; m+=2, adr+=2)
				{
		  		softdelay(30);
		  		zwei_bytes = (bytes[m+1]<<8) | bytes[m];
		  		write (adr, zwei_bytes);
         	    }
      		asc0_put('w');
			// asc0_put('\r');
			}
		else if (code==1) 		// End of File
			{
			asc0_put('s');
			// asc0_put('\r');
			}
		else if (code==2) 		// Extended Adress
			{
			extadress = (bytes[0]<<8 | bytes [1]) << 4; 
			asc0_put('e');
			// asc0_put('\r');
			}
		else if (code==3) 		// Auslesen
			{
			int start_adr;
			int ad = 0;
            buffer_pos = 0;
			adr=adresse;
			number = (bytes[0]<<8) | bytes [1];	   	// Auslesen wieviele Datenbytes gelesen werden sollen
			start_adr = adr;	  					// Auslesen, ab welcher Adresse gelesen werden soll
			adr+=2;
			//asc0_printf("numm= %d, st= %d", number, start_adr);
			asc0_printf("\n");
	  			for (m=0; m<number; m+=2, adr+=2)
			    {
		       	softdelay(30);
			   	zwei_bytes = read (ad);   				// Zwei Bytes auslesen
			   	ad++;
	 		   	bytes[buffer_pos]= zwei_bytes & 255;	// Bytes aufsplitten
			   	bytes[buffer_pos + 1]= (zwei_bytes >> 8) & 255;
               	buffer_pos += 2;

			   		if ( buffer_pos >= MAXHEXLINE )
			   		{    /* it's time to dump the buffer to a line in the file */
  				    write_hex_out (start_adr, bytes, buffer_pos);
					start_adr = adr;
					buffer_pos=0;
					}
            	}
		    if (buffer_pos != 0)
 		    	{
				write_hex_out (start_adr, bytes, buffer_pos);
		    	}
	        asc0_printf(":00000001FF\n");  /* end of file marker */
			asc0_put('r');
			}

		else if (code==4) 		// Lschen
			{
			clear();
			asc0_put('x');
			}
		asc0_put('t'); 			//bereit fr naechste Zeile
	}			
}
