;****************************************************************************************
;First level BOOTSTRAP LOADER

$INCLUDE (REG167.INC)
;
ASSUME  DPP2:NDATA
ASSUME	DPP3:SYSTEM

BOOTSTRAP SECTION CODE AT 0FA40H

BYTE_COUNTER 	EQU R1
ADDRESS 	EQU R2
NUMBER_BYTES 	EQU 0AAH 					;depending on the program size, 170 Byte BSL2
TRANS_START 	EQU 22H 					;Start Byte: 100010
STARTADDRESS 	EQU 0F600H 					;depending on settings
								;IRAM Start Address
								

;*****************************************************************************************

BOOT 	PROC NEAR

START: 		MOV S0TBUF, #TRANS_START 			;send start byte
	MOV BYTE_COUNTER, #NUMBER_BYTES
	MOV ADDRESS, #STARTADDRESS

LOOP:
READ: 		BCLR S0RIR					;Clear direct bit 2Byte
	WAIT: 	JNB S0RIR, WAIT					;Jump relative if direct bit is not set, 4 Byte

	    MOVB [ADDRESS], S0RBUF 				;store byte at ADDRESS
	    							
		 ADD ADDRESS, #1 				;inc ADDRESS
		 CMPD1 BYTE_COUNTER, #1				;Compare immediate word data to direct GPR and
								;decrement GPR by 1; 2 od 4 Byte

	    JMPR CC_UGE, LOOP					;Jump relative if condition is met 2Byte
	    
	    JMPA CC_UC, STARTADDRESS				;jump to IRAM Start Address, Jump absolute if condition is met 4Byte

BOOT 	    ENDP

BOOTSTRAP   ENDS

END
;****************************************************************************************
