$SEGMENTED
$INCLUDE (REG167.INC)
ASSUME DPP3: SYSTEM

BOOTSTRAP    SECTION CODE AT 0F600H

READ_BYTE 	EQU RL0
READ_WORD 	EQU R0

ADDRESS		EQU R1
ADDRESS_LOW 	EQU RL1
ADDRESS_HIGH 	EQU RH1

STARTADDRESS 	EQU R2
NUMBER_DATA 	EQU R3
_256_ 		EQU R4
SEGMENT_NR 	EQU R5
TEMP_VAR 	EQU RL6
CHECKSUM 	EQU R7

END_OF_FILE 	EQU PSW.6
TRANS_START 	EQU 55H


BOOT        PROC NEAR

START:      MOV SEGMENT_NR, #00H

 	    MOV SYSCON, #1234H 				;register initialization
	    MOV BUSCON0, #1234H

	    MOV ADDRSEL1,#1234H
            	 MOV BUSCON1, #1234H

	    MOV ADDRSEL2,#1234H
	    	 MOV BUSCON2, #1234H

	    MOV ADDRSEL3,#1234H
		 MOV BUSCON3, #1234H

	    MOV ADDRSEL4,#1234H
		 MOV BUSCON4, #1234H

	    CALLR INIT
		 MOV S0TBUF, #TRANS_START 		;send start byte

CONTINUE: 	 CALLR READ_LINE 			;read one line of the Hex-File
	    CALLR CHECK_SUM 				;verify the checksum byte

	    JNB END_OF_FILE, CONTINUE

	wait0:   JNB S0TIR, wait0

FINISH: 	 SRST 					;or JMPS ..,..

;*****************************************************************************************
INIT: 		 BCLR END_OF_FILE 			;some initializations
	    MOV _256_, #256	
	    BCLR S0RIR
	    RET
;*****************************************************************************************
READ: 							;sub routine that receives one byte
	WAIT1:   JNB S0RIR, WAIT1
	    MOVB READ_BYTE, S0RBUF
	    BCLR S0RIR
	    ADD CHECKSUM, READ_WORD
	    RET
;*****************************************************************************************
READ_LINE: 	MOV CHECKSUM, #00H 			;sub routine that receives one line
		 MOV READ_WORD, #00H

	    CALLR READ
	    CMPB READ_BYTE, #0
	    JMPR CC_EQ, DATA_RECORD
		CMPB READ_BYTE, #1
	    JMPR CC_EQ, EOF
		CMPB READ_BYTE, #2
	    JMPR CC_EQ, SEGMENT_ADDR_RECORD
		CMPB READ_BYTE, #4
	    JMPR CC_EQ, SEGMENT_ADDR_RECORD
		RET
;-----------------------------------------------------------------------------------------
DATA_RECORD: 	CALLR READ 				;data record line
	    MOV NUMBER_DATA, READ_WORD

	    CALLR READ
	    MOVB ADDRESS_HIGH, READ_BYTE
	    CALLR READ
	    MOVB ADDRESS_LOW, READ_BYTE

   	LOOP: 	CALLR READ
	    EXTS SEGMENT_NR, #1
	    MOVB [ADDRESS], READ_BYTE 			;store data byte
	    ADD ADDRESS, #1
	    CMPD1 NUMBER_DATA, #01H
 	    JMPR CC_NE, LOOP
	    RET
;-----------------------------------------------------------------------------------------
SEGMENT_ADDR_RECORD: 					;segment address record line
	    CALLR READ
	    MOV SEGMENT_NR, READ_WORD
	    RET
;-----------------------------------------------------------------------------------------
EOF: 							;end of file line
	    BSET END_OF_FILE
	    RET
;*****************************************************************************************
CHECK_SUM: 	MOV MDL, CHECKSUM 			;calculation of the checksum byte
	    NOP
	    DIVU _256_
	    NOP
	    MOVB TEMP_VAR, MDH
	    NEG TEMP_VAR
	    MOV S0TBUF,TEMP_VAR
 	    BCLR S0TIR
	    RET
;*****************************************************************************************
BOOT 	    ENDP

BOOTSTRAP   ENDS

	    END
