/* -*- mode: c; compile-command: "cd ..; make all"; -*- */
/*
 * Module:         Headerfile for error_handling.c
 * Author:         Guenter Ebermann
 * Matrikelnummer: tw01d022
 * Time-stamp:     <2003-01-21 23:08:54 guenter> 
 * File:           error_handling.h
 */

#ifndef _ERROR_HANDLING_H
#define _ERROR_HANDLING_H

#define MESSAGE_LEN 300 /* Maximum length of error-message */

typedef enum { MESSAGE, WARNING, BAIL_OUT } ERROR_TYPE;
/* the same as: */
/* #define MESSAGE 0 */
/* #define WARNING 1 */
/* #define BAIL_OUT 2 */

typedef enum { NORMAL, NORMAL_WARNING, NULLONE, NORESULT, NORESULT_BAILOUT } RESULT_QUALIFIER;
/* values of the RESULT_QUALIFIER: */
/* NORMAL: if (return_value < 0) -> BAIL_OUT
           if (return_value >=0) -> OK 
*/
/* NULLONE: if (return_value = 0) -> BAIL_OUT
            if (return_value >0) -> OK 
*/

void print_message (ERROR_TYPE error_type, const char *format, ...);
int is_ascii (const char *string);
void print_version (void);
void print_help (void);
void error_detection (int verbose, int result,  RESULT_QUALIFIER result_qualifier, const char *format, ...);

#endif /* _ERROR_HANDLING_H */

