#ifndef _FLASHTOOL_FUNCTIONS_H
#define _FLASHTOOL_FUNCTIONS_H

#define SEND_COMMAND_LENGTH 30 /* the max length of the instruction
				  set for the serial communication */

#define TRANSFER_LINE_LENGTH 255 /* the line length for a transered
				    line */

void send_command (bool verbose, int fd, unsigned char *command);
void hex_to_bin (bool verbose, char *filename, char *output_file_name);
int is_file_a_intel_hex_file (char *filename);
void initialize_micro_controller (int fd, bool verbose);
void transfer_bootstrap_loader (bool verbose, int fd, char *filename, char *output_file_name);
void transfer_bootstrap_loader_bsl3 (bool verbose, int fd, char *filename);
void intel_hex_to_data (bool verbose, char *filename, char *output_file_name);
void intel_hex_to_data_bsl3 (bool verbose, char *filename, char *output_file_name);
void transfer_ihex_file (bool verbose, int fd, char *filename);
void delete_flash_memory(bool verbose, int fd);
void read_flash_memory(bool verbose, int fd, int start, int stop);


#endif /* _FLASHTOOL_FUNCTIONS_H */
