/* This c functions are at the moment not used */

/* -------- Serial I/O functions with POSIX compliant read/write calls -------- */
/*******************************************************************************
 * _put_serial_line
 * Parameters:  fd: file descriptor to the serial port
 *              *wline: pointer to the line to be sent
 * Description: send a string to the serial interface
 */
int _put_serial_line_posix(int fd, unsigned char *wline) 
{
    int i, j = 0;
  
    for (i = 0; wline[i] != '\0'; i++)
	j += write(fd, &wline[i], 1);
  
    return(j);
}

/*******************************************************************************
 * _get_serial_line
 * Parameters:  fd: file descriptor to the serial port
 *              max: maximum line size
 *              *rline: global space to store the line returned
 * Return Value:  1 Success
 *               -1 Error
 * Description: get one '\n' terminated line from the serial interface 
 */
int _get_serial_line_posix(int fd, unsigned int max, unsigned char *rline, bool verbose) {
    int i,rl;
    unsigned char c;

    for (i=0; i<max; i++) 
      {    
	rl = read(fd, &c, 1);    
	if (verbose)
	  printf("got line: position = %d, value = 0x%X\n", i, c);    
	if (rl >= 0) 
	  {
	    if (c!='\n')
	      rline[i] = c;      
	    else
	      return(1);
	  } 
	else 
	  {      
	    if (verbose)
	      printf("error reading serial port\n");
	    return(-1);      
	  }
      }  
    return(1);
}

/* -------- Serial I/O functions with ANSI compliant calls -------- */
int _put_serial_line_ansi (FILE *fs, unsigned char *wline) {
  int i, j = 0;
  
  for (i = 0; wline[i] != '\0'; i++)
    j += fputc(wline[i], fs);
  
  return(j);
}

int _get_serial_line_ansi (FILE *fs, unsigned int max, unsigned char *rline, bool verbose) {
  int i,rl=0;
  unsigned char c;

  for (i=0; i<max; i++) 
    {    
      c = fgetc(fs);    
      if (verbose)
	printf("got line: position = %d, value = 0x%X\n", i, c);    
      if (rl >= 0) 
	{
	  if (c!='\n')
	    rline[i] = c;      
	  else
	    return(1);
	} 
      else 
	{      
	  if (verbose)
	    printf("error reading serial port\n");
	  return(-1);      
	}
    }  
  return(1);
}
